program getmessage;

{$APPTYPE console}

uses
  SysUtils,
  SysVMsgQueue;

const
  MQ_PATH_NAME = '/tmp/msg1';
  MAX_CHARS    = 80;

type
   TMyMsgQueueRecord = packed record
     MessageType : integer;
     MyInteger   : integer;
     MyFloat     : double;
     MyCharStr   : array[0..MAX_CHARS] of char;
   end;

var
   msg : TSystemVMQ;
   buf : TMyMsgQueueRecord;
   NumRead : integer;

begin
   writeln('Retrieving a message');
   msg              := TSystemVMQ.Create;

   writeln('Setting properties..');
   msg.Debug        := true;
   msg.PrivateKey   := false;
   msg.PathName     := MQ_PATH_NAME;
   msg.Permissions  := [fpOwnerRead, fpOwnerWrite, fpGroupRead, fpGroupWrite];
   msg.OpenExisting := false;  // create it if necessary
   msg.BlockOnRead  := true;
   writeln('Opening the msg queue..');
   msg.Open;

   // clear the message
   buf.MessageType := 0;
   buf.MyInteger   := 0;
   buf.MyFloat     := 0;
   StrPLCopy(buf.MyCharStr,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx',MAX_CHARS);

   writeln('receiving the message..');
   if not msg.Read(@buf, sizeof(TMyMsgQueueRecord) - sizeof(integer),1,NumRead) then
      writeln('error reading message!')
   else
   begin
      writeln('message received! read ',NumRead,' messages');
      writeln('contents of message');
      writeln('MessageType = ',buf.MessageType,' MyInteger = ',
               buf.MyInteger,' MyFloat = ',buf.MyFloat,
               ' MyCharStr = ',buf.MyCharStr);
      writeln;
   end;

   //msg.Close;
   msg.Free;
end.